// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.jdatabase;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Timer;

import jslovo.util.*;
import jslovo.ui.*;

public class DBmaker extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JPanel jPanel1;
	private JEditorPane boxmess;
	private JScrollPane scrollPane;
	private JButton jHB1;
	private JButton jHB2;
	private BorderLayout borderLayout1;
	private BorderLayout borderLayout2;
	private JFileChooser fc;
	private StatusMonitor statMon;

	public static String DicFile = "";
	public static String DicPath = "";
	public static String tmpMessage = "";

	private int delay1 = 0; // delay for 5 sec.
	private int period1 = 500; // repeat every sec.
	private Timer timer1; // main timer to update summary - always active

	// Instance attributes used in this dialog
	public DBmaker() {

		super(Global.mainFrame);

		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setTitle(ResourceLoader.getDisplay("ui.dbmaker"));
		setModal(true);
		setResizable(true);

		Font fon0 = new Font("Arial", Font.BOLD, 12);

		// define timer for pipe files
		timer1 = new Timer(period1, taskMessage);
		timer1.setRepeats(true);
		timer1.setInitialDelay(delay1);

		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		jPanel1 = new JPanel();
		jHB1 = new JButton();
		jHB2 = new JButton();
		borderLayout1 = new BorderLayout();
		borderLayout2 = new BorderLayout();

		contentPane = (JPanel) getContentPane();
		contentPane.setLayout(borderLayout1);
		setSize(new Dimension(420, 240));
		// contentPane.setPreferredSize(new Dimension(220, 335));
		// jPanel1.setLayout(flowLayout1);
		// jPanel1.setPreferredSize(new Dimension(220, 60));

		jPanel1.setLayout(borderLayout2);
		// jPanel1.setPreferredSize(new Dimension(220, 60));

		jPanel1.setToolTipText("");

		// Create a new listbox control
		boxmess = new JEditorPane();
		boxmess.setFont(fon0);
		boxmess.setAutoscrolls(true);
		boxmess.setEditable(false);
		boxmess.setContentType("text/html;charset=ISO-8859-1");

		boxmess.setText(ResourceLoader.getDisplay("database.howtomake"));
		// Add the listbox to a scrolling pane
		scrollPane = new JScrollPane();
		scrollPane.getViewport().add(boxmess);
		contentPane.add(scrollPane, BorderLayout.CENTER);

		jHB1.setText(ResourceLoader.getCommand("button.opendatabase"));
		jHB1.setPreferredSize(new Dimension(120, 30));

		jHB1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				// Create a file chooser
				fc = new JFileChooser();
				int returnVal = fc.showOpenDialog(DBmaker.this);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = fc.getSelectedFile();
					String sname = fc.getSelectedFile().getAbsolutePath();
					DicFile = file.getName();
					// System.out.println(sname);
					DicPath = StringUtil.replace(sname, DicFile, "");
					SetStatusMonitor.nn = 0;
					SetStatusMonitor.mess = "status";
					// dbslovoMake.SetDB(DicPath, DicFile);
					boxmess.setText("");
					timer1.start();
					new ThreadDB("Making DB");
				}
			}
		});

		jHB2.setText(ResourceLoader.getCommand("button.exitdatabase"));
		jHB2.setPreferredSize(new Dimension(120, 30));

		jHB2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				JOptionPane dialog1 = new JOptionPane();

				int ask = dialog1.showConfirmDialog(dialog1, ResourceLoader
						.getDisplay("message.exitdb"), ResourceLoader
						.getDisplay("message.question"),
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE, null);
				if (ask == JOptionPane.YES_OPTION) {
					SetStatusMonitor.nn = 0;
					SetStatusMonitor.mess = "status";
					setVisible(false);
					dispose();
				}
			}
		});

		// status
		statMon = new StatusMonitor();
		statMon.setPreferredSize(new java.awt.Dimension(420, 25));
		statMon.setMinimumSize(new java.awt.Dimension(30, 10));

		jPanel1.add(jHB1, BorderLayout.WEST);
		jPanel1.add(jHB2, BorderLayout.EAST);
		jPanel1.add(statMon, BorderLayout.NORTH);

		contentPane.add(jPanel1, java.awt.BorderLayout.SOUTH);

		setVisible();

	}

	// run
	class ThreadDB implements Runnable {

		Thread t;

		ThreadDB(String s1) {
			t = new Thread(this, s1);
			t.start();
		}

		public void run() {
			dbslovoMake.SetDB(DicPath, DicFile, Global.DBdir);
		}
	} // end Thread
	// -------------------------------------

	// timer task: update GUI
	ActionListener taskMessage = new ActionListener() {
		boolean alreadyDisposed = false;

		public void actionPerformed(ActionEvent ermc) {
			// initial state;
			if (!tmpMessage.equals(dbslovoMake.InfoStatus)) {
				boxmess.setText(dbslovoMake.InfoStatus);
				tmpMessage = dbslovoMake.InfoStatus;
			}
		};
	};

	// create about
	public void setVisible() {
		// store mainframe dimensions
		Dimension dim = Global.mainFrame.getSize();
		int w = dim.width;
		int h = dim.height;
		// Get the system resolution
		Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
		// make sure the dialog is not too big
		Dimension size = new Dimension(Math.min((int) (0.5 * w), res.width),
				Math.min((int) (0.8 * h), res.height));
		this.setSize(size);
		Util.centreWithin(Global.mainFrame, this);

		show();
	}

}
