// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;

import java.net.*;
import java.awt.*;
import javax.swing.*;

import jslovo.util.*;

public class  HelpDialog extends JDialog{
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JTabbedPane tabbedPane;
    private JButton closeButton;
    private	JPanel	panel1;
    private	JPanel	panel2;
    private     JPanel  panel3;

    public HelpDialog() {


   setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

   setModal( true );
   setResizable( true );


  JPanel topPanel = new JPanel();
  JPanel lowerPanel = new JPanel();
  lowerPanel.setPreferredSize(new Dimension(800, 35));


  closeButton = new JButton();
  closeButton.setText("Exit");
  closeButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
             setVisible(false); dispose();
        }  });

  lowerPanel.add(closeButton, null);
  topPanel.setLayout( new BorderLayout() );
  getContentPane().add( topPanel, java.awt.BorderLayout.CENTER );
  getContentPane().add( lowerPanel, java.awt.BorderLayout.SOUTH );



   tabbedPane = new javax.swing.JTabbedPane();
   // Create the tab pages
   //             createPage1("help_about.html");
                createPage1();         
                createPage2();
		createPage3();

		// Create a tabbed pane
		tabbedPane = new JTabbedPane();
		tabbedPane.addTab( "About JSlovo", panel1 );
		tabbedPane.addTab( "Searching database", panel2 );
                tabbedPane.addTab( "Making database", panel3 );
		topPanel.add( tabbedPane, BorderLayout.CENTER );

        setVisible(); 

    }



// create about 
      public void createPage1() { 

      panel1 = new JPanel();
      panel1.setLayout(new BorderLayout());
      JEditorPane epane = new JEditorPane();
      epane.setOpaque( false );
      epane.setContentType( "text/html;charset=ISO-8859-1" );
      epane.setAutoscrolls(true);
      epane.setEditable(false);
      String hstr = ResourceLoader.getCommand( "html.help.help" );
      URL page = ResourceLoader.getResourceURL( "#standards/" + hstr );
     try {
         epane.setPage( page );
      }
      catch ( Exception e )
      {
         System.err.println("Couldn't create URL: " + hstr);
         epane.setContentType( "text/plain" );
      }
       JScrollPane jsp = new JScrollPane(epane);
       panel1.add(jsp);

      }



// create about
      public void createPage2() {

      panel2 = new JPanel();
      panel2.setLayout(new BorderLayout());
      JEditorPane epane = new JEditorPane();
      epane.setOpaque( false );
      epane.setContentType( "text/html;charset=ISO-8859-1" );
      epane.setAutoscrolls(true);
      epane.setEditable(false);
      String hstr = ResourceLoader.getCommand( "html.help.searchdb" );
      URL page = ResourceLoader.getResourceURL( "#standards/" + hstr );
     try {
         epane.setPage( page );
      }
      catch ( Exception e )
      {
         System.err.println("Couldn't create URL: " + hstr);
         epane.setContentType( "text/plain" );
      }
       JScrollPane jsp = new JScrollPane(epane);
       panel2.add(jsp);

      }


// create about
      public void createPage3() {

      panel3 = new JPanel();
      panel3.setLayout(new BorderLayout());
      JEditorPane epane = new JEditorPane();
      epane.setOpaque( false );
      epane.setContentType( "text/html;charset=ISO-8859-1" );
      epane.setAutoscrolls(true);
      epane.setEditable(false);
      String hstr = ResourceLoader.getCommand( "html.help.makedb" );
      URL page = ResourceLoader.getResourceURL( "#standards/" + hstr );
     try {
         epane.setPage( page );
      }
      catch ( Exception e )
      {
         System.err.println("Couldn't create URL: " + hstr);
         epane.setContentType( "text/plain" );
      }
       JScrollPane jsp = new JScrollPane(epane);
       panel3.add(jsp);
      }


// create about
   public void setVisible() {
// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(1.1*w),res.width),
                        Math.min((int)(1.2*h), res.height) );
    this.setSize(size);
    Util.centreWithin( Global.mainFrame, this );

    show();
   }




}
