// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;

import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

import jslovo.util.*;

public class PanelSelectDic extends JPanel implements KeyListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public JTable jDicSelect;
	private JButton jB1;
	private JButton jB2;
	public MyTableModel myModel;
//	private JLabel dicnumber;
	public JButton jSearchButton;
	public JTextField SearchField;
	//private ReadDB dbase = null;

	public PanelSelectDic() {

		// get GUI width
		int wGUI = Options.getIntOption("frame.width");

		JPanel jtop = new JPanel(new BorderLayout());
		JPanel jbotom = new JPanel(new FlowLayout());
		jB1 = new JButton();
		jB2 = new JButton();
		SearchField = new JTextField();

		SearchField.addKeyListener(this);
		jSearchButton = new JButton();
		jSearchButton.setText(ResourceLoader.getCommand("button.search"));
		jSearchButton.setToolTipText(ResourceLoader.getDisplay("tip.search"));
		jSearchButton.addActionListener(Global.mainActionListener);

		Font fon0 = new Font("Arial", Font.BOLD, 12);
		jB1.setFont(fon0);
		jB2.setFont(fon0);
		jB1.setText(ResourceLoader.getCommand("button.select_all"));
		// jB1.setPreferredSize(new Dimension(60, 25));

		jB2.setText(ResourceLoader.getCommand("button.remove_all"));
		// jB2.setPreferredSize(new Dimension(100, 25));

		jtop.add(SearchField, java.awt.BorderLayout.CENTER);
		jtop.add(jSearchButton, java.awt.BorderLayout.SOUTH);

		Font fon1 = new Font("Arial", Font.BOLD, 14);
		SearchField.setFont(fon1);
		SearchField.setBorder(BorderFactory.createEtchedBorder());

		SearchField.setPreferredSize(new Dimension((int) (0.6 * wGUI), 24));
		SearchField.setMinimumSize(new java.awt.Dimension((int) (0.1 * wGUI),
				24));
		SearchField.setText("");

		// jB1.setPreferredSize(new Dimension(120, 22));
		// jB2.setPreferredSize(new Dimension(120, 22));

		// jtop.setBackground(new Color(215, 255, 255));
		// jtop.setPreferredSize(new Dimension(40, 55));
		jtop.setMinimumSize(new Dimension(10, 24));
		// jbotom.setBackground(new Color(215, 255, 255));
		jbotom.setPreferredSize(new Dimension(40, 30));
		jbotom.setMinimumSize(new Dimension(10, 24));
		jbotom.add(jB1, null);
		jbotom.add(jB2, null);

		// this.setPreferredSize(new Dimension(100, 300));
		this.setLayout(new BorderLayout());

		JScrollPane JScrollPane1 = new JScrollPane();
		// JScrollPane1.setPreferredSize(new Dimension(100, 300));
		JScrollPane1.setMinimumSize(new Dimension(10, 24));

		myModel = new MyTableModel();
		jDicSelect = new JTable(myModel);
		jDicSelect.setRowHeight(20);
		myModel.addColumn("");
		myModel.addColumn(ResourceLoader.getDisplay("ui.dictionary"));
		jDicSelect.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		/*
		 * //Ask to be notified of selection changes. ListSelectionModel rowSM =
		 * jDicSelect.getSelectionModel(); rowSM.addListSelectionListener(new
		 * ListSelectionListener() { public void valueChanged(ListSelectionEvent
		 * e) { //Ignore extra messages. if (e.getValueIsAdjusting()) return;
		 * 
		 * ListSelectionModel lsm = (ListSelectionModel)e.getSource(); if
		 * (lsm.isSelectionEmpty()) { // ...//no rows are selected } else { int
		 * selectedRow = lsm.getMinSelectionIndex(); // ...//selectedRow is
		 * selected System.out.println( "OK "+selectedRow ); } } });
		 */

		// channge size
		TableColumn column = null;
		column = jDicSelect.getColumnModel().getColumn(1);
		column.setPreferredWidth(100);
		column.setMinWidth(10);
		column.setMaxWidth(600);
		column = jDicSelect.getColumnModel().getColumn(0);
		column.setPreferredWidth(20);
		column.setMinWidth(10);
		column.setMaxWidth(30);

/*
		for (int i = 0; i < Global.dbbases.size(); i++) {
			String sdic = (String) Global.dbbases.get(i);
	                 myModel.addRow(new Object[] { new Boolean(Global.ActivateDic[i]), new String(sdic) });
		}
*/


		jDicSelect.getModel().addTableModelListener(
				new MyTableModelListener(jDicSelect));

		// select all
		jB1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {

				for (int i = 0; i < jDicSelect.getRowCount(); i++) {
					jDicSelect.setValueAt(new Boolean(true), i, 0);
					Global.ActivateDic[i] = true;
				}
				jDicSelect.repaint();
			}
		});

		// deselect all
		jB2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {

				for (int i = 0; i < jDicSelect.getRowCount(); i++) {
					jDicSelect.setValueAt(new Boolean(false), i, 0);
					Global.ActivateDic[i] = false;
				}
				jDicSelect.repaint();
			}
		});

		/*
		 * dicnumber = new JLabel();
		 * dicnumber.setText(Integer.toString(Global.Nmax
		 * )+"  dictionaries loaded "); jbotom.add(dicnumber);
		 */

		JScrollPane1.getViewport().add(jDicSelect);
		this.add(jbotom, java.awt.BorderLayout.SOUTH);
		this.add(JScrollPane1, java.awt.BorderLayout.CENTER);
		this.add(jtop, java.awt.BorderLayout.NORTH);

	}


       public void addDatabases(){

         for (int i = 0; i < Global.dbbases.size(); i++) {
                        String sdic = (String) Global.dbbases.get(i);
                         myModel.addRow(new Object[] { new Boolean(Global.ActivateDic[i]), new String(sdic) });
                }


       }



	// set variables from the file
	public void GetDic() {

		for (int i = 0; i < jDicSelect.getRowCount(); i++) {
			Global.ActivateDic[i] = false;
			Object tmp1 = jDicSelect.getValueAt(i, 0);
			Object tmp2 = jDicSelect.getValueAt(i, 1);
			String s1 = tmp1.toString();
			String s2 = tmp2.toString();
			if (s1.equals("true")) {
				// System.out.println( tmp1.toString()+ "  " + tmp2.toString()
				// );
				Global.ActivateDic[i] = true;
			}
		}
	}

	public class MyTableModelListener implements TableModelListener {
		JTable table;

		// It is necessary to keep the table since it is not possible
		// to determine the table from the event's source
		MyTableModelListener(JTable table) {
			this.table = table;
		}

		public void tableChanged(TableModelEvent e) {
			int firstRow = e.getFirstRow();
			int lastRow = e.getLastRow();
			int mColIndex = e.getColumn();

			// System.out.println( "OK3" );

			for (int i = 0; i < jDicSelect.getRowCount(); i++) {
				Global.ActivateDic[i] = false;
				Object tmp1 = jDicSelect.getValueAt(i, 0);
				Object tmp2 = jDicSelect.getValueAt(i, 1);
				String s1 = tmp1.toString();
				String s2 = tmp2.toString();
				if (s1.equals("true")) {
					// System.out.println( tmp1.toString()+ "  " +
					// tmp2.toString() );
					Global.ActivateDic[i] = true;
				}
				// System.out.println( Global.ActivateDic[i] );
			}

			// connect to DB
			try {
			} catch (Exception ex1) {
				ex1.printStackTrace(); // could not start db
				System.out.println("db error : DBderby");
			}

		}
	}

	@Override
	public void keyPressed(KeyEvent e) {
		// TODO Auto-generated method stub
		
        int key = e.getKeyCode();
        
        if (key == KeyEvent.VK_ENTER) {
            Toolkit.getDefaultToolkit().beep();
            
            Global.mainFrame.Search();
            
          //  System.out.println("ENTER pressed");
        }
		
	}

	@Override
	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void keyTyped(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}

} // end main class

